// components/goods/goodsItem.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    goodsInfo: {
      type: Object,
      value: {},
      observer: '_updateGoodsInfo'
    },
    imageSize: {
      type: String,
      value: 'small'
    },
    imageSouceName: {
      type: String,
      value: 'list_urls'
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    goodsImagePath: ''
  },

  /**
   * 组件的方法列表
   */
  methods: {
    _update (newV, oldV) {
      if (newV !== oldV) {
        this.setData({
          goodsInfo: newV
        })
      }
    },
    _setGoodsImagePath () {
      let imageUrls = this.data.goodsInfo.goodsImages

      let urlName = this.data.imageSouceName

      let size = this.data.imageSize
      var url = ''
      if (imageUrls && imageUrls !== 'null') {
        var imagesObj = JSON.parse(imageUrls)
        var urls = imagesObj[urlName]
        var len = urls.length
        switch (size) {
          case 'big':
            url = urls[len - 1]
            break
          case 'normal':
            url = urls[1]
            break
          case 'small':
            url = urls[0]
            break
        }
      }
      return url
    }
  },
  // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
  attached: function () {
    const imagePath = this._setGoodsImagePath()
    this.setData({
      goodsImagePath: imagePath
    })
  },
  moved: function () { },
  detached: function () { }
})
