// components/swiper/tSwiper.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    imgUrls: {
      type: Array,
      value: []
    },
    config: {
      type: Object,
      value: {
        indicatorDots: true,
        autoplay: true,
        interval: 2000,
        duration: 500,
        current: 0,
        circular: true,
        vertical: false,
        indicatorColor: '#e6e6e6',
        indicatorActiveColor: '#00833d'
      }
    }
  },

  /**
   * 组件的初始数据
   */
  data: {
    imageHeights: {},
    current: 0,
    sysRes: wx.getSystemInfoSync()
  },

  /**
   * 组件的方法列表
   */
  methods: {
    // _tap (e) {
    //   const swiperTapDetail = e.detail // detail对象，提供给事件监听函数
    //   const swiperTapOption = {
    //     item: e.currentTarget.dataset.item
    //   } // 触发事件的选项
    // },
    bindChange: function (e) {
      this.setData({
        current: e.detail.current
      })
    },
    imageLoad: function (e) { // 图片加载完成回调
      const sysRes = this.data.sysRes
      var imageWidth = e.detail.width
      var imageHeight = e.detail.height
      var ratio = imageWidth / imageHeight
      var imageHeights = this.data.imageHeights
      imageHeights[e.target.id] = sysRes.windowWidth / ratio
      this.setData({
        imageHeights: imageHeights
      })
    }
  },
  // 生命周期函数，可以为函数，或一个在methods段中定义的方法名
  attached: function () {
    if (Object.keys(this.data.config).length > 0) {
      this.setData({
        ...this.data.config
      })
    }
  }
  // moved: function () { },
  // detached: function () { },
})
