const app = getApp()
// const api = require('../../utils/api.js')
// const pageParmas = require('../../../../utils/common').parmas
// const wxService = require('../../../../utils/wxService')
// const utils = require('../../../../utils/util')
const wxService = require('../../../utils/wxService')
const utils = require('../../../utils/util')
const envInfo = require('../../../config/index').envInfo

const addGoods = utils._.debounce(function () {
    let _scope = this
    let storeInventoryQuantity = _scope.data.storeLimitNum
    let storeName = _scope.data.goodInfo.storeName
    const vaildate = this.validateStockNum()
    if (!vaildate) {
        return false
    }
    wx.showLoading({
        title: '正在加载...',
        mask: true
    })
    api.customer.post('i-shopCart/add', {
        storeId: _scope.data.storeId,
        storeInventoryQuantity,
        cartType: 2,
        storeName,
        skuCode: _scope.data.barCode,
        quantity: 1
    }).then(res => {

    }).finally(() => {
        wx.hideLoading()
        wx.showToast({
            title: '加入购物车成功',
            icon: 'success',
            duration: 1500
        })
        this.getUserShopCartCount()
    })
}, 300)
const buyNow = utils._.debounce(function () {
    let _scope = this
    if (!this.validateOrder(_scope.data.storeLimitNum, _scope.data.payOrderConfig)) {
        return false
    }
    const vaildate = this.validateStockNum()
    if (!vaildate) {
        return false
    }
    // 传给商品提交页面的参数对象
    pageParmas.setObject('_goodsDetail', {
        goodsList: [{
            quantity: 1,
            skuCode: _scope.data.goodInfo.barCode
        }],
        storeId: _scope.data.storeId
    })
    wxService.router('../goodDetail/goodDetail').search({
        from: 'goods_detail'
    })
}, 300)
wxService.page({
    data: {
        goodInfo: {}, // 商品信息
        colorUrl1: '../images/choose-color.png', // 边框
        colorUrl2: '../images/choose-border.png', // 选中边框
        custNo: null, // 用户编号
        skuId: '',
        barCode: null, // 商品编码
        price: null, // 商品价格
        count: null, // 商品数量
        stock: false, // 库存不足提示标识
        loadingShow: true,
        storeName: null,
        storeId: null,
        images: [],
        showDot: true,   //是否显示轮播图点
        storeLimitNum: 0,
        payOrderConfig: {}, // 下单配置
        // isFirst: app.globalData.loginFirst,
        isFirst: false,
        carNum: 0,
        scanCode: true,

        showProGuarantee: false,   //是否展示商品质保弹窗
        scrollTips: '继续拖动，查看图文详情', // 滑动文案
        showHtml: false,
    },

    //展示服务说明
    showProGuarantee() {
        this.setData({
            showProGuarantee: true
        })
    },
    // 页面touchstart事件
    pageTouchStart: function (e) {
        if (this.data.showHtml) {
            return
        }
        this.setData({
            reachBottom: false,
            startTouchY: null
        })
    },

    // 页面touchend事件
    pageMoveEnd: function (e) {
        if (this.data.showHtml) {
            return
        }
        if (!e.changedTouches[0]) {
            return;
        }
        if (this.data.startTouchY - e.changedTouches[0].pageY >= 50) {
            this.setData({
                showHtml: true,
                scrollTips: ''
            })
        }
    },

    // 页面touchmove事件
    pageMove: function (e) {
        if (this.data.showHtml) {
            return
        }
        wx.createSelectorQuery().selectViewport().scrollOffset((pageRes) => {
            wx.createSelectorQuery().select('.product-container').fields({
                size: true
            }, (res) => {
                if (res.height >= app.globalData.systemInfo.windowHeight + pageRes.scrollTop) {
                    this.setData({
                        reachBottom: true
                    })
                } else {
                    if (this.data.reachBottom) {
                        this.setData({
                            reachBottom: false
                        })
                    }
                }
                if (this.data.startTouchY == null && e.changedTouches[0]) {
                    this.setData({
                        startTouchY: e.changedTouches[0].pageY
                    })
                }
            }).exec()
        }).exec()
    },
    //返回顶部
    returnTop() {
        wx.pageScrollTo({
            scrollTop: 0
        })
    },
    // 关闭提示
    closeTips() {
        // app.globalData.loginFirst = false
        this.setData({
            isFirst: false
        })
    },
    closeMask() {
        this.setData({
            stock: 0
        })
    },
    // 跳转购物车
    toCar: function () {
        // 传给购物车的参数
        wxService
            .router('/subPackage/express/pages/car/car')
            .search({
                // custNo: this.data.custNo
                custNo: app.globalData.baseUserInfo.custNo
            })
    },
    // 扫一扫
    scan: function () {
        // 小程序扫一扫api
        wx.scanCode({
            onlyFromCamera: true,
            scanType: 'qrCode',
            success: (res) => {
                let param = res.path
                let str = JSON.stringify(param).split('=')[1].split('"')[0]
                // 把扫到的参数传到商品详情页
                wx.navigateTo({
                    url: '../index/index?scene=' + str
                })
            }
        })
    },
    // 添加购物车
    addGood: addGoods,
    validateStockNum() {
        let res = true
        if (!this.data.goodInfo.stockNum) {
            this.setData({
                stock: 1
            })
            wx.reportAnalytics('express_api_pay_fail', {
                token: wx.getStorageSync('token'),
                storeid: this.data.storeId,
                skucode: this.data.skuId
            })
            res = false
        }
        return res
    },

    // 验证是否满足下单设置
    validateOrder(storeLimitNum, { inventoryLimitQuantity, inventoryLimitFlag }) {
        let pass = false
        if (inventoryLimitFlag && (inventoryLimitQuantity - storeLimitNum > 0)) {
            pass = true
        } else if (!inventoryLimitFlag) {
            pass = true
        } else {
            wx.showToast({
                title: '本商品门店有货,您可以向导购咨询后,直接在门店进行购买。',
                icon: 'none'
            })
            wx.reportAnalytics('express_api_nopay_2', {
                token: wx.getStorageSync('token'),
                storeid: this.data.storeId,
                skucode: this.data.skuId
            })
        }
        return pass
    },
    // 立即购买
    buyNow: buyNow,
    // 页面初始化
    init: function (params) {
        let _scope = this
        let storeId = params[0]
        let skuId = params[1]
        let storeLimitNum = params[2]
        app.globalData.storeId = storeId
        app.globalData.storeInventoryQuantity = storeLimitNum || 0
        this.setData({
            skuId
        })
        wx.showLoading({
            title: '加载中'
        })
        // 获取下单配置
        // api.orderConfig.get('i-offline-order/config', { orderConfigId: 1 }).
        wxService.get(`i-offline-order/config`, { orderConfigId: 1 }).then(res => {
            this.data.payOrderConfig = res
        })
        // 获取用户信息
        // app.getUserInfo().then(({ custNo }) => {
        // api.detail.get('i-goods/offline/detail', {
        //     storeId: storeId,
        //     skuCode: skuId
        // }).
        
        
        wxService.get(`i-goods/offline/detail`,{
            storeId: storeId,
            skuCode: skuId
        }).then(data => {
            const imageUrls = (data.posterImgUrlList && data.posterImgUrlList.length) ? data.posterImgUrlList : ['https://hwimagecdn.ihotwind.cn/hotwind-mini/images/kuaididaojia/kuaidaojia_default_goods_big.png']// 默认图片;

            const showDot = (data.posterImgUrlList && data.posterImgUrlList.length) ? true : false

            if (imageUrls) {
                _scope.setData({
                    images: imageUrls,
                    showDot: showDot
                })
            }
            app.globalData.storeName = data.storeName
            wxService.get('/i-mini/offlineGoodsStatistical', {
                skuCode: skuId,
                storeId: storeId,
                storeName: data.storeName
            })
            wxService.nextTick(() => {
                this.setData({
                    goodInfo: data,
                    barCode: data.barCode,
                    price: data.price,
                    count: data.stockNum,
                    loadingShow: false,
                    storeName: data.storeName,
                    storeId: storeId,
                    storeLimitNum
                })
            })
        }).finally(() => {
            wx.hideLoading()
        })
        // })
    },
    getUserShopCartCount() {
        wxService.get(`shopCart/getUserShopCartCount?cartType=2`).then(res => {
            const { data } = res
            if (data.code == 200) {
                this.setData({
                    carNum: data.data
                })
            }
        })
    },
    onLoad: function (options) {
        let _scope = this
        var params = decodeURIComponent(options.scene).split(':')
        if (params.length === 2) {
            params.push(0)
        }

        let storeId = params[0]
        let skuId = params[1]
        if (!storeId || !skuId) {
            wx.showModal({
                content: '参数格式错误，请联系客服',
                showCancel: false,
                confirmText: '知道了'
            })

            return false
        }

        _scope.init(params)
    },
    judgeDate() {
        let y = (new Date()).getFullYear();
        let m = (new Date()).getMonth();
        let d = (new Date()).getDate();
        let _compDate = wx.getStorageSync('_compDateExpress');
        let date = String(y) + String(m) + String(d);

        if (!_compDate) {
            wx.setStorageSync('_compDateExpress', date);
            return true;
        } else {
            if (date * 1 === _compDate * 1) {
                return false;
            } else {
                wx.setStorageSync('_compDateExpress', date);
                return true;
            }
        }
    },
    onShow() {
        let baseUserInfo = wx.getStorageSync('_baseUserInfo')
        if (this.judgeDate()) {
            this.setData({
                isFirst: true
            })
        }

        if (baseUserInfo && baseUserInfo.isMember === '1') { //授权并且是会员
            this.getUserShopCartCount()
        }

    }
})
