// share/share.js
const wxService = require('../../../../utils/wxService')
const utils = require('../../../../utils/util')
const envInfo = require('../../../../config/index').envInfo
const app = getApp()


wxService.page({
    data: {
        bannerImg: '',
        listData: [[], [], []],
        current: 0,
        typeArr: [1, 2, 3]
    },

    onLoad: function (options) {
        this.getProductList();
        this.getImg();
    },

    getImg() {
        wxService.post(`/sale/specialPriceActivate/getPropagandaSet`).then(res => {
            if (res.data.data && res.data.data.imgList.length > 0) {
                this.setData({
                    bannerImg: res.data.data.imgList[0]
                })
            }
        })
    },

    getProductList(current) {
        current = current ? current : 0;
        wxService.post(`/sale/specialPriceActivate/getActivityProductList?type=${this.data.typeArr[current]}`).then(res => {
            let data = res.data.data?res.data.data:[];
            data.map(item => {
                item.activityPriceText = item.activityPrice ? String((item.activityPrice / 10 / 10).toFixed(2)).split('.') : ['00', '00'];
                item.salePriceText = item.productPrice ? String((item.productPrice / 10 / 10).toFixed(2)).split('.') : ['00', '00'];
                item.per = (item.salesCount / item.repertory).toFixed(2) * 10 * 10;
                item.width = item.per / 10 / 10 * 254;

                return item;
            });
            let list = this.data.listData;
            list[current] = data;
            this.setData({
                listData: list
            })
        })
    },

    linkToProInfo(e) {
        let productId = e.currentTarget.dataset.productid;
        wxService.router(`/pages/productDetail/productDetail?id=${productId}`);
    },

    //消息订阅
    subscribeClick(e) {
        let activeId = e.currentTarget.dataset.id;
        let itemIndex = e.currentTarget.dataset.index;

        let baseUserInfo = wx.getStorageSync('_baseUserInfo');
        wxService.post(`${'/merchant/message/wxSubMsgMapping/getListByParams'}`, {
            scenarioIds: ['usernoticeappointment'],
            sourceFrom: 2,
            switchType: 3
        }).then(res => {
            let tempArr = res.data.data ? res.data.data : [];
            let tempids = [];
            tempArr.map(item => {
                tempids.push(item.templateId);
            });
            console.log(tempids)
            wx.requestSubscribeMessage({
                tmplIds: tempids,
                success: (res) => {
                    for (let i = 0; i < tempArr.length; i++) {
                        wxService.post(`${'/merchant/message/wxSubMsgSubscride/member/subscribe'}`, {
                            businessId: activeId,
                            memberId: baseUserInfo.memberId,
                            scenarioId: tempArr[i].scenarioId,
                            templateId: tempArr[i].templateId
                        }).then(resp => { });
                    }
                    if(tempids.length>0){
                        let status = res[tempids[0]];
                        if(status == 'accept'){
                            let list = this.data.listData;
                            list[this.data.current][itemIndex].isAppointMent = true;
                            this.setData({
                                listData: list
                            })
                            wx.showToast({
                                title: '预约成功',
                            })
                        }
                    }
                },
                complete: (res) => {
                    console.log(res)
                }
            })
        }).catch(err => {})
    },

    changeTab(e) {
        this.setData({
            current: e.target.dataset.current * 1
        })
    },

    swiperChange(e) {
        let current = e.detail.current;
        this.setData({
            current: current
        })
        if (this.data.listData[current].length === 0) {
            this.getProductList(current);
        }
        // this.getProductList(current);
    },

    onShow: function () {

    },

});